<template>
  <!-- If forcing creation bar, init tabs with tab 1 instead of 0 -->
  <v-tabs v-model="selectedTab" vertical>
    <template
      v-for="slot, slotName in tabs"
    >
      <v-tab
        v-show="!hideLabels"
        :key="slotName + '-tab'"
        class="editor-tab"
      >
        <v-icon left>
          {{ slot.icon }}
        </v-icon>
        {{ slot.label }}
      </v-tab>
      <!-- The button creation bar slot -->
      <v-tab-item
        :key="slotName + '-tab'"
        transition="slide-y-transition"
      >
        <slot :name="slotName" />
      </v-tab-item>
    </template>
    <!-- The button to hide the editor bar -->
    <!-- grey--text, pl-6 and mt-auto are vuetify helpers -->
    <v-btn
      v-if="!noHideButton"
      text tile
      class="editor-tab grey--text pl-6 mt-auto "
      @click="$emit('hide')"
    >
      <v-icon left>
        mdi-chevron-double-down
      </v-icon>
      {{ $t('button.hide') }}
    </v-btn>
  </v-tabs>
</template>

<script lang="ts">
import {
  Vue, Component, VModel, Prop,
} from 'vue-property-decorator';

export interface EditorTab {
  label: string;
  icon: string;
}

/**
 * Displays selectable tabs and a hide button
 */
@Component
export default class BarTabs extends Vue {
  @VModel()
  selectedTab!: number;

  @Prop()
  tabs!: Record<string, EditorTab>;

  @Prop({ default: false })
  hideLabels!: boolean;

  @Prop({ default: false })
  noHideButton!: boolean;
}
</script>
<style scoped lang="scss">
.editor-tab {
  justify-content: left;
}
</style>
